// NpMsgrUser.h: interface for the CNpMsgrUser class.
//
//////////////////////////////////////////////////////////////////////
#pragma once
#pragma warning( disable : 4786 )

#include <string>

using namespace std;

#include "INpMsgr.h"


/**
	@ingroup	NpMsgr
	@brief		޽ ýۿ  ڸ ߻ȭ INpMsgrUser ̽  Ŭ.
	@author		翵
*/
class CNpMsgrUser : public INpMsgrUser
{
//	int Assign_Ret_MBCSStringBuffer( LPCWSTR wstr );
//	int m_nCurrentStringBufferLength;
//	char * m_pszCurrentStringBuffer;
public:
	CNpMsgrUser();
	virtual ~CNpMsgrUser();

	void Clear();

private:
	string m_strAuthCookie;
	
public:	
	E_MSGR_LOGIN_STATUS m_eLoginStatus;

	WSTRING m_wstrInputLoginId;

	WSTRING m_wstrId;
	string m_strPassword;
	WSTRING m_wstrNick;
	WSTRING m_wstrName;
	WSTRING m_wstrMobilePhone;
	
	E_MSGR_ONLINE_STATUS m_eOnlineStatus;
	E_MSGR_IPT_STATUS m_eIPTStatus;
	
	/* <NEW FEATURE BY MOBILE> */
	WSTRING m_wstrProfileImageName;
	string m_strProfileImageCRC;
	WSTRING m_wstrIntro;
	string m_strMobileNumberHash;
	unsigned short m_nAllowInviteType;
	bool m_bAdultFlag;
	bool m_bDdosWarning;
	unsigned short m_nAge;
	int m_nPenaltyStep;
	int m_nCacheSerial_Buddy;
	int m_nCacheSerial_Group;
	int m_nCacheSerial_Invite;
	int m_nCacheSerial_Spec;
	int m_nCacheSerial_RoomMetaData;
	int m_nCacheSerial_MobileAddressBook;
	int m_nCacheSerial_BuddyAddressBook;
	int m_nCacheSerial_MobileBlock;
	int m_nCacheSerial_RelayServer;
    int m_nMobileCheckResultBits;
    unsigned short m_nMobilePushAlarmTypeBits;
	unsigned short m_nLaunchingResultBits;
	string m_strLaunchingResultURL;
	
//	string m_strTcpCAddr;
//	string m_strUdpCAddr;

	int m_nLocaleCode;

	virtual LPCWSTR Id() { return m_wstrId.c_str(); }
	virtual LPCWSTR LoginInputId() { return m_wstrInputLoginId.c_str(); }
	//virtual unsigned char * Id_UTF8();
	//virtual LPCSTR Id_MBCS();
	virtual LPCSTR Password() { return m_strPassword.c_str(); }
	virtual LPCWSTR Nick() { return m_wstrNick.c_str(); }
	virtual LPCWSTR Name() { return m_wstrName.c_str(); }
	virtual LPCWSTR MobilePhone() { return m_wstrMobilePhone.c_str(); }
	virtual LPCSTR AuthCookie() { return m_strAuthCookie.c_str(); }
	virtual void SetAuthCookie( LPCSTR strCookie );
	virtual void ClearAuthCookie() { m_strAuthCookie.clear(); }
	
	virtual LPCWSTR ProfileImageName() { return m_wstrProfileImageName.c_str(); }
	virtual LPCSTR ProfileImageCRC() { return m_strProfileImageCRC.c_str(); }
	virtual LPCWSTR Intro() { return m_wstrIntro.c_str(); }
	virtual LPCSTR MobileNumberHash() { return m_strMobileNumberHash.c_str(); }
	
	virtual unsigned short AllowInviteType() { return m_nAllowInviteType; }
	virtual bool IsAdult() { return m_bAdultFlag; }
	virtual bool IsDdosWarning() { return m_bDdosWarning; }
	virtual unsigned short Age() { return m_nAge; }
	virtual int PenaltyStep() { return m_nPenaltyStep; }
    virtual int MobileCheckResultBits() { return m_nMobileCheckResultBits; }
    virtual unsigned short MobilePushAlarmTypeBits() { return m_nMobilePushAlarmTypeBits; } 
	
	virtual int CacheSerial_Buddy() { return m_nCacheSerial_Buddy; }
	virtual int CacheSerial_Group() { return m_nCacheSerial_Group; }
	virtual int CacheSerial_Invite() { return m_nCacheSerial_Invite; }
	virtual int CacheSerial_Spec() { return m_nCacheSerial_Spec; }
	virtual int CacheSerial_RoomMetaData() { return m_nCacheSerial_RoomMetaData; }
	virtual int CacheSerial_MobileAddressBook() { return m_nCacheSerial_MobileAddressBook; }
	virtual int CacheSerial_BuddyAddressBook() { return m_nCacheSerial_BuddyAddressBook; }
	virtual int CacheSerial_MobileBlock() { return m_nCacheSerial_MobileBlock; }
	virtual int CacheSerial_RelayServer() { return m_nCacheSerial_RelayServer; }

	virtual unsigned short LaunchingCheckResult() { return m_nLaunchingResultBits; }
	virtual LPCSTR LaunchingResultURL() { return m_strLaunchingResultURL.c_str(); }
	
	virtual void SetCacheSerial_Buddy(int nSerial) { m_nCacheSerial_Buddy = nSerial; }
	virtual void SetCacheSerial_Group(int nSerial) { m_nCacheSerial_Group = nSerial; }
	virtual void SetCacheSerial_Invite(int nSerial) { m_nCacheSerial_Invite = nSerial; }
	virtual void SetCacheSerial_Spec(int nSerial) { m_nCacheSerial_Spec = nSerial; }
	virtual void SetCacheSerial_RoomMetaData(int nSerial) { m_nCacheSerial_RoomMetaData = nSerial; }
	virtual void SetCacheSerial_MobileAddressBook(int nSerial) { m_nCacheSerial_MobileAddressBook = nSerial; }
    virtual void SetCacheSerial_BuddyAddressBook(int nSerial) { m_nCacheSerial_BuddyAddressBook = nSerial; }
	virtual void SetCacheSerial_MobileBlock(int nSerial) { m_nCacheSerial_MobileBlock = nSerial; }
	virtual void SetCacheSerial_RelayServer(int nSerial) { m_nCacheSerial_RelayServer = nSerial; }
	
	virtual E_MSGR_ONLINE_STATUS OnlineStatus() { return m_eOnlineStatus; }
	virtual E_MSGR_LOGIN_STATUS LoginStatus() { return m_eLoginStatus; }

	virtual E_MSGR_IPT_STATUS IPTStatus() { return m_eIPTStatus; }
	
	//virtual LPCSTR Nick_MBCS();
	//virtual LPCSTR Name_MBCS();
	//virtual LPCSTR MobilePhone_MBCS();
	
	virtual int LocaleCode() { return m_nLocaleCode; }
};
